.TH audioi810 7D "5 September 2003"
.SH NAME
audioi810 \- Intel ICH, ICH0, ICH2, ICH4 audio controller device driver
.SH SYNOPSIS
.nf
.B audioi810:sound,audio
.B audioi810:sound,audioctl
.fi
.SH DESCRIPTION

The
.B audioi810
driver is a STREAMS based audio device driver for the Intel ICH, ICH0,
ICH2 and ICH4 audio controller, found in mainboard chipsets from Intel.


.SH APPLICATION PROGRAMMING INTERFACE
The Intel ICH audio device is treated as an exclusive resource; only
one process may open the device at a time for read or write access.
However, one process may open the device read-only (for recording
audio samples), while a second process may open the device write-only
(for playing audio samples).

This driver attempts to provide an implementation of the standard Sun audio
API.


.SS Audio Data Formats

The Intel ICH audio controller uses 16-bit stereo samples in two's
complement format (16-bit PCM).  If available, a hardware sample rate
converter in the AC'97 codec is used, to allow playback and recording
of audio data at rates from 8,000 to 48,000 samples per second.
If the system contains an AC'97 codec without optional hardware sample
rate converter, sample rates are converted to the AC'97 fixed codec
speed of 48,000 samples per second using a simple software sample
rate converter inside the audio driver, using a linear interpolation
method.

The native ICH audio data format corresponds to an encoding of
AUDIO_ENCODING_LINEAR with precision 16. The
.B audioi810
driver also generates and accepts the encodings AUDIO_ENCODING_ULAW,
AUDIO_ENCODING_ALAW, AUDIO_ENCODING_LINEAR and AUDIO_ENCODING_LINEAR8,
all with precision 8.  These encodings are converted per software into
16-bit PCM format inside the driver.


.SS Audio Ports

Currently the only output port supported is the external headphone
jack, so the
.I play.port
field in the audio information structure only supports AUDIO_HEADPHONE.
Output volume is controlled by software.

The
.I record.port
field of the audio information structure allows selection of which
audio source is used for recording, and may be set to one of
AUDIO_MICROPHONE, AUDIO_LINE_IN, AUDIO_CD, AUDIO_AUX1_IN,
AUDIO_AUX2_IN or AUDIO_CODEC_LOOPB_IN.  These select input from the
microphone jack, line-level input jack, internal CD input, internal
telephone answering device, internal audio from TV tuner or internal codec
loopback respectively.

.SH FILES
.PD 0
.TP 20
.B /dev/audio
linked to /dev/sound/0
.TP
.B /dev/audioctl
linked to /dev/sound/0ctl
.TP
.B /dev/sound/0
first audio device in the system
.TP
.B /dev/sound/0ctl
audio control for the first audio device
.PD
.SH SEE ALSO
.BR audioconvert (1),
.BR ioctl (2),
.BR audio (7I),
.BR streamio (7I)

.I Intel 82801AA (ICH) & Intel 82801AB (ICH0) I/O Controller Hub
.I AC'97 Programmer's Reference Manual
.I (Order Number: 298028-001)

.I Intel 82801AA (ICH) and Intel 82801AB (ICH0) I/O Controller Hub
.I (Order Number: 290655-003)

.SH NOTES
The
.B audioi810
driver will return "SUNW,CS4231" in the 
.I name
field of the audio_device structure.  This is the name of the audio
hardware in some SPARC based systems from Sun Microsystems and is not
the correct driver name for the Intel ICH hardware.  The wrong
name was intentionally choosen to work around problems with hardcoded
audio_device names in various audio programs (audiotool, the Java JDK,
workman, ...) that derive information about the capabilities of the
audio device from the
.I name
field of the audio_device structure.  The name "SUNW,CS4231" was
choosen because this type of SPARC hardware supports roughly the same
features as the Intel ICH audio controller.

The
.I version
field of the audio_device structure contains the PCI revision byte of
the card as a two character hex string, a comma and the decoded
hardware name of the card. The
.I config
field contains "i810".

.SH BUGS
The
.BR mixer (7I)
interface is not yet supported.
