/*
    Soundblaster 16 PCI driver for Solaris.
    @(#) ac97.h 2.1@(#)

    Written by Philip Brown <phil@bolthole.com>
    Rewritten by Jrgen Keil <jk@tools.de>

    Copyright  2000       Philip Brown
    Copyright  2000, 2001 Jrgen Keil

    This driver is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This driver is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this driver; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
*/

/* Here are defines for the intel-specification "AC 97".
 * It stands for "AudioCodec (19)97" or something like that.
 * Sniff around
 * http://developer.intel.com/ial/scalableplatforms/audio/index.htm
 * for the actual spec.
 *
 * It should be noted that we talk to an
 * "AC97 Controller" interface, which itself talks to the 
 *   actual "AC97" chip.
 */

#define AC97_RESETREG	0x00	/* write anything to this, for reset */

#define AC97_MASTERVOL	0x02
#define AC97_AUXOUTVOL	0x04
#define AC97_HEADPHONEVOL 0x04	/* alternate name for aux out */
#define AC97_MONOVOL	0x06	/* "master mono volume": huh? */
#define	AC97_MASTERTONE	0x08
#define	AC97_BEEPVOL	0x0a
#define AC97_PHONEVOL	0x0c
#define AC97_MICVOL	0x0e
#define AC97_LINEINVOL	0x10
#define AC97_CDVOL	0x12
#define AC97_VIDEOVOL	0x14
#define AC97_AUXVOL	0x16
#define AC97_PCMVOL	0x18
#define	AC97_RECSELCTL	0x1a	/* record select control */
#define	AC97_RECGAIN	0x1c	/* record gain */
#define	AC97_RECGAINMIC	0x1e	/* opt: record gain for microphone */
#define	AC97_GENPURPOSE	0x20
#define	AC97_3DCTL	0x22
#define	AC97_RESERVED	0x24
#define	AC97_POWERDOWN	0x26
#define AC97_XID	0x28	/* identifies supported extensions */
#define AC97_XCONTROL	0x2a	/* "extended" control */
#define AC97_DACRATE	0x2c
#define AC97_DAC2RATE	0x2e	/* surround sound */
#define AC97_LFERATE	0x30	/* no I dont know what LFE is */
#define AC97_ADCRATE	0x32	/* ADC == record */
#define AC97_MICRATE	0x32	/* microphone rate */

#define AC97_VOL	0x36	/* Center/LFE (DAC) vol */
#define AC97_VOL2	0x38	/* Surround (DAC2) vol */

#define AC97_VENDOR1	0x7c
#define AC97_VENDOR2	0x7e
