.TH audiov8233 7D "1 December 2001"
.SH NAME
audiov8233 \- VIA VT8233 audio controller device driver
.SH SYNOPSIS
.nf
.B audiov8233:sound,audio
.B audiov8233:sound,audioctl
.fi
.SH DESCRIPTION

The
.B audiov8233
driver is a STREAMS based audio device driver for the VIA VT8233
audio controller, found in mainboard chipsets from VIA Technologies, Inc.


.SH APPLICATION PROGRAMMING INTERFACE
The VIA 8233 audio device is treated as an exclusive resource; only
one process may open the device at a time for read or write access.
However, one process may open the device read-only (for recording
audio samples), while a second process may open the device write-only
(for playing audio samples).

This driver attempts to provide an implementation of the standard Sun audio
API.


.SS Audio Data Formats

The VIA 8233 audio controller uses 16-bit mono or stereo samples in two's
complement format (16-bit PCM), or 8-bit mono or stereo samples in
excess-128 format (8-bit unsigned linear PCM).
Audio data is sampled at rates from
8,000 to 48,000 samples per seconds.

The native VIA audio data format corresponds to an encoding of
AUDIO_ENCODING_LINEAR with precision 16 or AUDIO_ENCODING_LINEAR8 with
precision 8. The
.B audiov8233
driver also generates and accepts the encodings AUDIO_ENCODING_ULAW,
AUDIO_ENCODING_ALAW and AUDIO_ENCODING_LINEAR 
all with precision 8.  These encodings are converted per software into
16-bit PCM format inside the driver.


.SS Audio Ports

Currently the only output port supported is the external headphone
jack, so the
.I play.port
field in the audio information structure only supports AUDIO_HEADPHONE.
Output volume is controlled by software.

The
.I record.port
field of the audio information structure allows selection of which
audio source is used for recording, and may be set to one of
AUDIO_MICROPHONE, AUDIO_LINE_IN, AUDIO_CD, AUDIO_AUX1_IN,
AUDIO_AUX2_IN or AUDIO_CODEC_LOOPB_IN.  These select input from the
microphone jack, line-level input jack, internal CD input, internal
telephone answering device, internal audio from TV tuner or internal codec
loopback respectively.

.SH FILES
.PD 0
.TP 20
.B /dev/audio
linked to /dev/sound/0
.TP
.B /dev/audioctl
linked to /dev/sound/0ctl
.TP
.B /dev/sound/0
first audio device in the system
.TP
.B /dev/sound/0ctl
audio control for the first audio device
.PD
.SH SEE ALSO
.BR audioconvert (1),
.BR ioctl (2),
.BR audio (7I),
.BR streamio (7I)

.I "VT82C686A 'Super South' South Bridge Data Sheet"

.SH NOTES
The
.B audiov8233
driver will return "SUNW,CS4231" in the 
.I name
field of the audio_device structure.  This is the name of the audio
hardware in some SPARC based systems from Sun Microsystems and is not
the correct driver name for the VIA 8233 hardware.  The wrong
name was intentionally choosen to work around problems with hardcoded
audio_device names in various audio programs (audiotool, the Java JDK,
workman, ...) that derive information about the capabilities of the
audio device from the
.I name
field of the audio_device structure.  The name "SUNW,CS4231" was
choosen because this type of SPARC hardware supports roughly the same
features as the VIA 8233 audio controller.

The
.I version
field of the audio_device structure contains the PCI revision byte of
the card as a two character hex string, a comma and the decoded
hardware name of the card. The
.I config
field contains "via8233".

.SH BUGS
The
.BR mixer (7I)
interface is not yet supported.
